<template>
  <v-data-table
    :headers="headers"
    :loading="loading"
    :items="shipments"
    :page="page"
    :items-per-page="pageSize"
    :server-items-length="total"
    class="elevation-1"
    @click:row="gotToDetails"
  >
    <template #item.id="{ item }">
      {{ hashId({ id: item.id }) }}
    </template>
    <template #item.arrivalTime="{ item }">
      {{ toLocalDate(item.arrivalTime) }}
    </template>
  </v-data-table>
</template>

<script>
import { mapActions, mapState } from 'vuex';
import { toLocalDate } from '~/helpers/format/time';
import { hashId } from '~/helpers/format/ids';

export default {
  name: 'ShipmentsTable',
  data: () => ({
    loading: false,
    headers: [
      {
        text: 'Nª',
        align: 'start',
        sortable: false,
        value: 'id',
      },
      {
        text: 'Hora de llegada',
        sortable: false,
        value: 'arrivalTime',
      },
      {
        text: 'Vehículo (Placa)',
        sortable: false,
        value: 'licensePlate',
      },
      {
        text: 'Estado',
        sortable: false,
        value: 'state',
      },
    ],
  }),
  computed: {
    ...mapState({
      shipments: state => state.storage.shipments.shipments,
      page: state => state.storage.shipments.pageInfo.page,
      pageSize: state => state.storage.shipments.pageInfo.pageSize,
      total: state => state.storage.shipments.pageInfo.total,
    }),
  },
  async mounted() {
    await this.getShipmentsData();
  },
  methods: {
    toLocalDate,
    hashId,
    ...mapActions({
      getShipments: 'storage/shipments/getShipments',
    }),
    async getShipmentsData() {
      this.loading = true;
      try {
        await this.getShipments({});
      } catch (e) {
        console.error(e);
      }
      this.loading = false;
    },
    async gotToDetails({ id }) {
      await this.$router.push(`/almacenamiento/envios/${id}`);
    },
  },
};
</script>
